// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'ngCordova', 'starter.controllers'])//, 'starter.services'

.run(function ($ionicPlatform, $ionicPopup) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
        }

        if(window.Connection) {
            if(navigator.connection.type == Connection.NONE) {
                $ionicPopup.alert({
                    title: "Internet Disconnected",
                    content: "<div style='direction:rtl;'><strong>برای استفاده از برنامه ‌Bazar360 باید به اینترنت متصل باشید.</strong></div><br/>For using Bazar360 app, your device should be connected to the Internet."
                })
                .then(function(result) {
                    // if(!result) {
                        ionic.Platform.exitApp();
                    // }
                });
            }
    }

        // Enable to debug issues.
  // window.plugins.OneSignal.setLogLevel({logLevel: 4, visualLevel: 4});
  
  var notificationOpenedCallback = function(jsonData) {
    console.log('notificationOpenedCallback: ' + JSON.stringify(jsonData));
  };

  window.plugins.OneSignal
    .startInit("38d91a87-9359-47ea-af1e-4db9fcdcd02c")
    .handleNotificationOpened(notificationOpenedCallback)
    .endInit();
    
  // Call syncHashedEmail anywhere in your app if you have the user's email.
  // This improves the effectiveness of OneSignal's "best-time" notification scheduling feature.
  // window.plugins.OneSignal.syncHashedEmail(userEmail);
  });
})

.config(function($stateProvider, $urlRouterProvider) {

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  $stateProvider

  // setup an abstract state for the tabs directive
    .state('tab', {
            url: "/tab",
    abstract: true,
            templateUrl: "templates/tabs.html"
  })

  // Each tab has its own nav history stack:

        .state('tab.website', {
            url: '/website',
    views: {
                'tab-website': {
                    templateUrl: 'templates/tab-website.html',
                    controller: 'WebsiteCtrl'
      }
    }
  })

        .state('tab.settings', {
            url: '/settings',
            views: {
                'tab-settings': {
                    templateUrl: 'templates/tab-settings.html',
                    controller: 'SettingsCtrl'
        }
      }
    })

        .state('tab.social', {
            url: '/social',
            views: {
                'tab-social': {
                    templateUrl: 'templates/tab-social.html',
                    controller: 'SocialCtrl'
      }
    }
  });

  // if none of the above states are matched, use this as the fallback
    $urlRouterProvider.otherwise('/tab/website');

});
