angular.module('starter.controllers', [])

.controller('WebsiteCtrl', function ($scope, $ionicPlatform, $ionicPopup,  $cordovaFile, $cordovaFileTransfer, $cordovaAppVersion) {
    $scope.installationId = '';
    $ionicPlatform.ready(function() {
        try {
            // window.plugins.OneSignal.promptLocation();

            window.plugins.OneSignal.getTags(function(tags) {
                console.log('Tags Received: ' + JSON.stringify(tags));                

                if (!tags["initAll"]) {
                    window.plugins.OneSignal.sendTags({
                                      "push0830" : "I",
                                      "push1030" : "I",
                                      "push1400" : "I",
                                      "push1700" : "I",
                                      "specialOffers" : "I",
                                      "specialEvents" : "I",
                                      "deviceType" : "Ionic",
                                      "initAll" : "I"
                                      });
                }
            });

        } catch (err) {
        }

    });

    var updateCheckInterval = 2000;

    // $scope.latestVersion = false;
    // $scope.currentVersion = false;
    // $scope.downloadUrl = false;
    var currentVersion;

    var platformIsLoaded = false;

    $ionicPlatform.ready(function() {
        try {
            // alert("checking current version");
            cordova.getAppVersion().then(function (version) { // getVersionNumber
                currentVersion = version; 
                // alert("current version is " + currentVersion);
            });
        } catch (err) {
            // currentVersion = "1.0";
            // alert(err.message);
        }

        platformIsLoaded= true;
    });

    var updateCheckTimer = setTimeout(checkForUpdate, updateCheckInterval);
    var checkedForUpdate = false;

    function checkForUpdate() {
        if (!platformIsLoaded){
            updateCheckTimer = setTimeout(checkForUpdate, updateCheckInterval);
            return;
        }

        console.log("currentVersion: " +  currentVersion + "\r\n latestVersion: " + latestVersion + "\r\n downloadUrl: " + downloadUrl + "\r\n checkedForUpdate: " + checkedForUpdate);

        if ((currentVersion != false) && (latestVersion != false) && (downloadUrl != false)) {
            checkedForUpdate = true;

            if (parseFloat(currentVersion) < parseFloat(latestVersion)) {
                console.log("new version is available");
                // alert(downloadUrl);
                // Download new version:
                // var uniq = Math.floor((Math.random() * 1000) + 1);
                
                // var targetPath = "cdvfile://localhost/temporary/";
                // var targetPath = "cdvfile://localhost/persistent/";
                // var targetPath = cordova.file.dataDirectory;
                var targetPath = cordova.file.externalCacheDirectory;

                targetPath = targetPath +  "Bazar360.ver." + latestVersion + ".apk";
                // var targetPath = cordova.file.toInternalURL(cordova.file.dataDirectory +  "Bazar360.ver." + latestVersion + ".apk");

                console.log("download new version to: " + targetPath);
                var trustHosts = true
                var options = {};
                try {
                    $cordovaFileTransfer.download(downloadUrl, targetPath, options, trustHosts)
                      .then(function(downloadresult) {
                        console.log("New Version Url: " + downloadresult.toURL());
                        // Success!
                        window.plugins.webintent.startActivity({
                                                                    action: window.plugins.webintent.ACTION_VIEW,
                                                                    url: downloadresult.toURL(),
                                                                    type: 'application/vnd.android.package-archive'
                                                                },
                                                                function () {
                                                                },
                                                                function () {
                                                                    console.log("Failed to open URL via Android Intent. URL: " + downloadresult.toURL());
                                                                });
                      }, function(err) {
                        // Error
                        console.log("download error source " + err.source);
                        console.log("download error target " + err.target);
                        console.log("download error codes " + err.code);
                      }, function (progress) {
                        // $timeout(function () {
                        //   $scope.downloadProgress = (progress.loaded / progress.total) * 100;
                        // })
                        // var percent = ((progress.loaded / progress.total) * 100);
                        // console.log("download progress: (" + percent + "%) " + progress.loaded + " of "  + progress.total);
                      });
                } catch (err) {
                    console.log(err.message);
                }
            }
        }

        if (updateCheckTimer) {
            clearTimeout(updateCheckTimer);
            updateCheckTimer = null;
        }

        if (checkedForUpdate == false)
            updateCheckTimer = setTimeout(checkForUpdate, updateCheckInterval);
    }

})

.controller('SocialCtrl', function ($scope, $cordovaDialogs) { // , $cordovaSmsPlugin
        $scope.socialNetworks = [
            {
                Type: 'facebook',
                Label: 'Bazar360 در فیسبوک',
                Location: 'http://facebook.com/Bazar360',
                icon: 'img/facebook@2x.png'
            },
            {
                Type: 'twitter',
                Label: 'Bazar360 در تویتر',
                Location: 'http://twitter.com/Bazar360',
                icon: 'img/twitter@2x.png'
            }
        ];
        $scope.contacts = [
            {
                Type: 'sms',
                Label: 'ارسال SMS برای ما',
                Location: 'sms:+989123964593?body=نظر شما در مورد Bazar360:',
                icon: 'img/SMS@2x.png'
            },
            {
                Type:'email',
                Label: 'ارسال Email برای ما',
                Location: 'mailto:info@bazar360.com?subject=Bazar360%20Android%20Feedback',
                icon: 'img/mail@2x.png'
            }
        ];

        $scope.tellOthers = [
            {
                Type: 'smsFriend',
                Label: 'Bazar360 را با SMS به دوستانتان معرفی کنید!',
                Location: 'sms:?body=این برنامه رو دانلود کن و از نرخ ارز در لحظه با خبر باش! http://app.bazar360.com',
                icon: 'img/SMS@2x.png'
            },
            {
                Type:'emailFriend',
                Label: 'Bazar360 را با Email به دوستانتان معرفی کنید!',
                Location: 'mailto:?subject=Bazar360%20(App.Bazar360.com)&body=این برنامه رو دانلود کن و از نرخ ارز در لحظه با خبر باش! http://app.bazar360.com',
                icon: 'img/mail@2x.png'
            }
        ];

        $scope.openUrl = function (item) {
            //if (item.Type == 'sms') {
            //    $cordovaDialogs.prompt("Bazar360 App Feedback", "Send Us SMS", ["Send", "Cancel"], "Bazar360 App Feedback:", function(message) {
            //        //$cordovaSmsPlugin.send('+989123964593', message, { android: { intent: 'INTENT' } }, function() {
            //        sms.send('+989123964593', message, { android: { intent: 'INTENT' } }, function() {
            //            $cordovaDialogs.alert("Thanks!", 'Thanks!', 'OK');
            //        }, function() {
            //            window.open(item.Location, '_system');
            //        });
            //    });
            //} else
                window.open(item.Location, '_system');
        };

    })

.controller('SettingsCtrl', function ($scope, $cordovaDialogs,  $window, $q, $ionicPlatform) {// $cordovaParsePlugin,
    $scope.settingsList = [
      { text: "ارسال نرخ ارز - صبح", value: "push0830", checked: false },
      { text: "ارسال نرخ ارز - پیش از ظهر", value: "push1030", checked: false },
      { text: "ارسال نرخ ارز - ظهر", value: "push1400", checked: false },
      { text: "ارسال نرخ ارز - عصر", value: "push1700", checked: false },
      { text: "تغییرات بیش از پنچ درصد", value: "pushFivePercent", checked: false },
      { text: "تغییرات بیش از چهار درصد", value: "pushFourPercent", checked: false },
      { text: "تغییرات بیش از سه درصد", value: "pushThreePercent", checked: false },
      { text: "تغییرات بیش از دو درصد", value: "pushTwoPercent", checked: false },
      { text: "تغییرات بیش از یک درصد", value: "pushOnePercent", checked: false },
      { text: "تغییرات بیش از نیم درصد", value: "pushHalfPercent", checked: false },
      { text: "پیشنهاد های ویژه", value: "specialOffers", checked: false },
      { text: "اتفاقات خاص", value: "specialEvents", checked: false }
    ];

    $scope.dictSettingsList = {};
    $scope.settingsList.forEach(function (x) {
        $scope.dictSettingsList[x.value] = x;
    });

    $scope.pushNotificationChange = function (item) {
        var channel = item.value;
        //alert(item.value);
        //alert('Push Notification Change' + $scope.dictSettingsList[item.value].text + " : " + $scope.dictSettingsList[item.value].checked);
        try {
            if ($scope.dictSettingsList[channel].checked) {
                window.plugins.OneSignal.sendTag(channel, "U");
            } else {
                window.plugins.OneSignal.deleteTag(channel);
            }
        } catch (e) {

        }
    };

    $ionicPlatform.ready(function () {
        try {
            window.plugins.OneSignal.getTags(function(tags) {
                $scope.settingsList.forEach(function(element) {
                    try {
                        $scope.dictSettingsList[element.value].checked = tags[element.value] ? true : false;
                    } catch (err) {
                        console.log('OneSignal Get Tag Error ' + err.message);                        
                    }
                }, this);
            });
        } catch (err) {
            console.log('OneSignal Error ' + err.message);
            // alert('OneSignal Error ' + err.message);
            $scope.settingsList = {};
        }

    });

    $scope.alert = function () {
        //$ionicPlatform.ready(function () {
        //    $cordovaParsePlugin.getSubscriptions().then(function (success) {
        //        $scope.mylist = 'success ' + JSON.stringify(success);
        //        $cordovaDialogs.alert($scope.mylist, 'Success', 'OK');
        //    }, function (error) {
        //        $scope.mylist = 'error ' + JSON.stringify(error);
        //        $cordovaDialogs.alert($scope.mylist, 'Error', 'OK');
        //    });
        //});
    };

});
